////////////////////////////////////////////////////////////////////////////////
// auls_addshortcut.cpp
////////////////////////////////////////////////////////////////////////////////

#include <aulslib/aviutl.h>
#include <aulslib/exedit.h>
#include <aulslib/memref.h>

using namespace auls;



static const LPSTR FILTER_NAME = "V[gJbgǉ";
static const LPSTR FILTER_INFORMATION = "AulsV[gJbgǉ";

static const int SHORTCUT_ID_BEGIN = 4000;

static const char FILTER_CATEGORY[] = {
	// 0 : gpȂ
	// 1 : ̓tB^
	// 2 : o̓tB^
	// 3 : tB^
	// 4 : tB^
	// 5 : tB^IuWFNg
	1, //  0 : t@C
	1, //  1 : 摜t@C
	1, //  2 : t@C
	1, //  3 : eLXg
	1, //  4 : }`
	1, //  5 : t[obt@
	1, //  6 : g`\
	1, //  7 : V[
	1, //  8 : V[()
	1, //  9 : OIuWFNg
	2, // 10 : W`
	2, // 11 : g`
	0, // 12 : WĐ // o̓tB^͂PȂ̂ōڂ͕sv
	2, // 13 : p[eBNo
	5, // 14 : V[`FW
	4, // 15 : F␳
	5, // 16 : F␳
	4, // 17 : NbsO
	4, // 18 : ڂ
	4, // 19 : Eڂ
	5, // 20 : ڂ
	4, // 21 : UCN
	5, // 22 : UCN
	4, // 23 : 
	5, // 24 : 
	4, // 25 : M
	4, // 26 : gU
	5, // 27 : gU
	4, // 28 : O[
	5, // 29 : O[
	4, // 30 : N}L[
	4, // 31 : J[L[
	4, // 32 : ~iXL[
	4, // 33 : Cg
	4, // 34 : Vh[
	4, // 35 : 
	4, // 36 : ʃGbW
	4, // 37 : GbWo
	4, // 38 : V[v
	4, // 39 : tF[h
	4, // 40 : Cv
	4, // 41 : }XN
	4, // 42 : ΂߃NbsO
	4, // 43 : ˃u[
	5, // 44 : ˃u[
	4, // 45 : u[
	5, // 46 : u[
	4, // 47 : Yu[
	5, // 48 : Yu[
	4, // 49 : [Vu[
	5, // 50 : [Vu[
	4, // 51 : W
	4, // 52 : g嗦
	4, // 53 : x
	4, // 54 : ]
	4, // 55 : ̈g
	4, // 56 : TCY
	4, // 57 : [e[V
	4, // 58 : U
	5, // 59 : U
	4, // 60 : ]
	5, // 61 : ]
	4, // 62 : ~[
	4, // 63 : X^[
	5, // 64 : X^[
	4, // 65 : g
	4, // 66 : 摜[v
	5, // 67 : 摜[v
	4, // 68 : ɍWϊ
	4, // 69 : fBXvCXg}bv
	4, // 70 : mCY
	4, // 71 : F
	5, // 72 : F
	4, // 73 : PF
	5, // 74 : PF
	4, // 75 : Of[V
	4, // 76 : gFݒ
	5, // 77 : gFݒ
	4, // 78 : Fϊ
	4, // 79 : Aj[V
	1, // 80 : JX^IuWFNg
	4, // 81 : XNvg
	4, // 82 : t@C
	4, // 83 : 摜t@C
	4, // 84 : C^[[X
	4, // 85 : JIvV
	4, // 86 : ItXN[`
	4, // 87 : IuWFNg
	5, // 88 : tB^
	0, // 89 : ʃtF[h // tB^ʂ̓^CCɒڔzuĂʂA
	0, // 90 : fBC // Ȃ̂ňꗗIԂȂƔfV[gJbg珜O
	5, // 91 : fBC
	0, // 92 : m // tB^
	3, // 93 : Ԑ
	3, // 94 : O[v
	3, // 95 : J
	0, // 96 : J(g`) // Â@\(?)Ȃ̂ŎgpȂ
	4, // 97 : J
	4, // 98 : Vh[(J)
	4, // 99 : XNvg(J)
};

struct MENUITEM {
	int id;
	LPSTR name;
};

const MENUITEM EXEDIT_MENU[] = {
	{ 1037, "IuWFNgt@C̃C|[g" },
	{ 1038, "IuWFNgt@C̃GNX|[g" },
	{ 1088, "SẴIuWFNgI" },
	{ 1089, "J[\ȍ~ɊJnIuWFNgI" },
	{ 1090, "J[\ȑOɏIIuWFNgI" },
	{ 1051, "IIuWFNgׂĕ"}, // ͕̕܂Ƃ߂ĕłȂ̂Œǉ
	{ 1057, "O[v" },
	{ 1058, "O[v" },

	/*/ C[֘A
	{ 1025, "C[̕\" },
	{ 1075, "̃C[S\/\" },
	{ 1032, "C[̑}" },
	{ 1033, "C[̍폜" },
	{ 1056, "C[ύX" },
	{ 1026, "C[̃bN" },
	{ 1062, "W̃N" },
	{ 1065, "̃IuWFNgŃNbsO(C[)" },
	//*/

	{ 1069, "̃IuWFNgŃNbsO" },
	{ 1081, "J̑Ώ" },
	{ 1083, "Obh(J)̕\" },
	{ 1093, "ΏۃC[͈͂̕\" },
	{ 1029, "IIuWFNg̒Ǐ]" },
	{ 1034, "IuWFNgXibv" },
	{ 1096, "V[̐ݒ" },
	{ 1014, "ݒ" },
};

enum SHORTCUT_MENU_ID {
	SMI_SET_TARGET_1 = SHORTCUT_ID_BEGIN,
	SMI_SET_TARGET_2,
	SMI_SET_TARGET_3,
	SMI_SET_TARGET_4,
	SMI_SET_TARGET_5,
	SMI_SET_TARGET_6,
	SMI_SET_TARGET_7,
	SMI_SET_TARGET_8,
	SMI_SET_TARGET_9,
	SMI_SET_TARGET_10,
	SMI_SET_TARGET_11,
	SMI_SET_TARGET_12,
	SMI_TARGET_MOVEUP,
	SMI_TARGET_MOVEDOWN,
	SMI_TARGET_DELETE,
	SMI_TARGET_INIT,
	SMI_TARGET_VALIDATE,
	SMI_TARGET_FOLD,
	SMI_FILTER_TARGET_MAKE_ALIAS,
	SMI_FILTER_VALIDATE_ALL,
	SMI_FILTER_INVALIDATE_EXCEPT_TOP_AND_TARGET,
	SMI_FILTER_FOLD_EXCEPT_TARGET,
	SMI_FILTER_UNFOLD_ALL,
	SMI_OBJDLG_RESET_POS,
	SMI_CHANGE_MEDIA_DEST,
	SMI_CHANGE_EFFECT_DEST,
	SMI_CHANGE_FILTER_DEST,
	SMI_SELECT_SCENE,
};

const MENUITEM SHORTCUT_MENU[] = {
	{ SMI_SET_TARGET_1, "1Ԗڂ̃tB^𑀍Ώۂɂ" },
	{ SMI_SET_TARGET_2, "2Ԗڂ̃tB^𑀍Ώۂɂ" },
	{ SMI_SET_TARGET_3, "3Ԗڂ̃tB^𑀍Ώۂɂ" },
	{ SMI_SET_TARGET_4, "4Ԗڂ̃tB^𑀍Ώۂɂ" },
	{ SMI_SET_TARGET_5, "5Ԗڂ̃tB^𑀍Ώۂɂ" },
	{ SMI_SET_TARGET_6, "6Ԗڂ̃tB^𑀍Ώۂɂ" },
	{ SMI_SET_TARGET_7, "7Ԗڂ̃tB^𑀍Ώۂɂ" },
	{ SMI_SET_TARGET_8, "8Ԗڂ̃tB^𑀍Ώۂɂ" },
	{ SMI_SET_TARGET_9, "9Ԗڂ̃tB^𑀍Ώۂɂ" },
	{ SMI_SET_TARGET_10, "10Ԗڂ̃tB^𑀍Ώۂɂ" },
	{ SMI_SET_TARGET_11, "11Ԗڂ̃tB^𑀍Ώۂɂ" },
	{ SMI_SET_TARGET_12, "12Ԗڂ̃tB^𑀍Ώۂɂ" },
	{ SMI_TARGET_MOVEUP, "ΏۃtB^Ɉړ" },
	{ SMI_TARGET_MOVEDOWN, "ΏۃtB^Ɉړ" },
	{ SMI_TARGET_DELETE, "ΏۃtB^폜" },
	{ SMI_TARGET_INIT, "ΏۃtB^" },
	{ SMI_TARGET_VALIDATE, "ΏۃtB^̗L/؂ւ" },
	{ SMI_TARGET_FOLD, "ΏۃtB^܂肽" },
	{ SMI_FILTER_TARGET_MAKE_ALIAS, "ΏۃtB^̃GCAX쐬" },
	{ SMI_FILTER_VALIDATE_ALL, "SẴtB^Lɂ" },
	{ SMI_FILTER_INVALIDATE_EXCEPT_TOP_AND_TARGET, "擪ƑΏۈȊÕtB^𖳌ɂ" },
	{ SMI_FILTER_FOLD_EXCEPT_TARGET, "ΏۈȊÕtB^܂肽" },
	{ SMI_FILTER_UNFOLD_ALL, "SẴtB^WJ" },
	{ SMI_OBJDLG_RESET_POS, "ݒ_CAÖʒuZbg" },
	{ SMI_CHANGE_MEDIA_DEST, "fBAIuWFNg̔zuύX" },
	{ SMI_CHANGE_EFFECT_DEST, "tB^ʂ̔zuύX" },
	{ SMI_CHANGE_FILTER_DEST, "tB^IuWFNg̔zuύX" },
	{ SMI_SELECT_SCENE, "V[I" },
};

////////////////////////////////////////////////////////////////////////////////
// IuWFNg_CAONX
////////////////////////////////////////////////////////////////////////////////

class CObjectDialog {
public:
	HWND hwnd;
	EXEDIT_OBJECT** obj_table;
	int  *obj_index;
	int  *cmd_target;
	BYTE *filter_status; // ܂肽ݑꊇōsɂ͐ݒ_CAOɃRs[ꂽtB^Xe[^XύXKv

	bool SetMemory(CMemref *memref)
	{
		OBJECT_BUFFER_INFO* obi = memref->Exedit_ObjectBufferInfo();
		if(!obi) return false;
		obj_table = &(obi->data);
		obj_index = memref->Exedit_ObjDlg_ObjectIndex();
		cmd_target = memref->Exedit_ObjDlg_CommandTarget();
		filter_status = memref->Exedit_ObjDlg_FilterStatus();

		return obj_table && obj_index && cmd_target && filter_status;
	}

	void ResetWindowPos(void)
	{
		RECT wr, dr;
		GetWindowRect(hwnd, &wr);
		SystemParametersInfo(SPI_GETWORKAREA, 0, &dr, 0);
		MoveWindow(hwnd, dr.right - (wr.right - wr.left), dr.top, wr.right - wr.left, wr.bottom - wr.top, TRUE);
	}

	EXEDIT_OBJECT* GetObject(void)
	{
		if(*obj_index == -1) return NULL;
		else return (*obj_table) + *obj_index;
	}

	bool FilterMoveUp(int index)
	{
		EXEDIT_OBJECT *obj = GetObject();
		if(!obj) return false;

		int min = (obj->type & (obj->TYPE_OVERLAY | obj->TYPE_CONTROL)) ? 2 : 1;
		int max = (obj->type & obj->TYPE_OVERLAY) ? obj->GetFilterNum()-2 : obj->GetFilterNum()-1;

		if(index < min || index > max) return false;

		*cmd_target = index;
		SendMessage(hwnd, WM_COMMAND, OBJDLG_COMMAND::FILTER_MOVEUP, 0);
		return true;
	}

	bool FilterMoveDown(int index)
	{
		EXEDIT_OBJECT *obj = GetObject();
		if(!obj) return false;

		int min = (obj->type & (obj->TYPE_OVERLAY | obj->TYPE_CONTROL)) ? 1 : 0;
		int max = (obj->type & obj->TYPE_OVERLAY) ? obj->GetFilterNum()-3 : obj->GetFilterNum()-2;

		if(index < min || index > max) return false;

		*cmd_target = index;
		SendMessage(hwnd, WM_COMMAND, OBJDLG_COMMAND::FILTER_MOVEDOWN, 0);
		return true;
	}

	bool FilterDelete(int index)
	{
		EXEDIT_OBJECT *obj = GetObject();
		if(!obj) return false;

		if(obj->GetFilterNum() == 1) return false;
		int min = (obj->type & (obj->TYPE_OVERLAY | obj->TYPE_CONTROL)) ? 1 : 0;
		int max = (obj->type & obj->TYPE_OVERLAY) ? obj->GetFilterNum()-2 : obj->GetFilterNum()-1;
		
		if(index < min || index > max) return false;

		*cmd_target = index;
		SendMessage(hwnd, WM_COMMAND, OBJDLG_COMMAND::FILTER_DELETE, 0);
		return true;
	}

	bool FilterInit(int index)
	{
		EXEDIT_OBJECT *obj = GetObject();
		if(!obj) return false;

		int max = (obj->type & obj->TYPE_OVERLAY) ? obj->GetFilterNum()-2 : obj->GetFilterNum()-1;

		if(index > max) return false;

		*cmd_target = index;
		SendMessage(hwnd, WM_COMMAND, OBJDLG_COMMAND::FILTER_INIT, 0);
		return true;
	}

	bool FilterValidate(int index)
	{
		EXEDIT_OBJECT *obj = GetObject();
		if(!obj) return false;

		int max = (obj->type & obj->TYPE_OVERLAY) ? obj->GetFilterNum()-2 : obj->GetFilterNum()-1;
		
		if(index > max) return false;

		CheckDlgButton(hwnd, OBJDLG_COMMAND::FILTER_VALIDATE+index, !IsDlgButtonChecked(hwnd, OBJDLG_COMMAND::FILTER_VALIDATE+index));
		SendMessage(hwnd, WM_COMMAND, OBJDLG_COMMAND::FILTER_VALIDATE+index, 0);
		return true;
	}

	bool FilterFold(int index)
	{
		EXEDIT_OBJECT *obj = GetObject();
		if(!obj) return false;

		int max = (obj->type & obj->TYPE_OVERLAY) ? obj->GetFilterNum()-2 : obj->GetFilterNum()-1;

		if(index > max) return false;

		SendMessage(hwnd, WM_COMMAND, OBJDLG_COMMAND::FILTER_FOLD+index, 0);
		return true;
	}

	bool FilterMakeAlias(int index)
	{
		EXEDIT_OBJECT *obj = GetObject();
		if(!obj) return false;

		int max = (obj->type & obj->TYPE_OVERLAY) ? obj->GetFilterNum()-2 : obj->GetFilterNum()-1;

		if(index > max) return false;

		*cmd_target = index;
		SendMessage(hwnd, WM_COMMAND, OBJDLG_COMMAND::FILTER_MAKE_ALIAS, 0);
		return true;
	}

	bool FilterValidateAll(void)
	{
		EXEDIT_OBJECT *obj = GetObject();
		if(!obj) return false;

		int max = (obj->type & obj->TYPE_OVERLAY) ? obj->GetFilterNum()-2 : obj->GetFilterNum()-1;

		for(int i = 0; i <= max; i++) {
			CheckDlgButton(hwnd, OBJDLG_COMMAND::FILTER_VALIDATE+i, BST_CHECKED);
			SendMessage(hwnd, WM_COMMAND, OBJDLG_COMMAND::FILTER_VALIDATE+i, 0);
		}
		return true;
	}

	bool FilterInvalidateExceptTopAndTarget(int index)
	{
		EXEDIT_OBJECT *obj = GetObject();
		if(!obj) return false;

		int max = (obj->type & obj->TYPE_OVERLAY) ? obj->GetFilterNum()-2 : obj->GetFilterNum()-1;

		for(int i = 0; i <= max; i++) {
			CheckDlgButton(hwnd, OBJDLG_COMMAND::FILTER_VALIDATE+i, i==0 || i==index);
			SendMessage(hwnd, WM_COMMAND, OBJDLG_COMMAND::FILTER_VALIDATE+i, 0);
		}
		return true;
	}

	bool FilterFoldExceptTarget(int index)
	{
		EXEDIT_OBJECT *obj = GetObject();
		if(!obj) return false;

		int max = (obj->type & obj->TYPE_OVERLAY) ? obj->GetFilterNum()-2 : obj->GetFilterNum()-1;

		for(int i = 0; i <= max; i++) {
			filter_status[i] |= obj->FILTER_STATUS_FOLD;
		}
		SendMessage(hwnd, WM_COMMAND, OBJDLG_COMMAND::FILTER_FOLD+index, 0);
		return true;
	}

	bool FilterUnfoldAll(void)
	{
		EXEDIT_OBJECT *obj = GetObject();
		if(!obj) return false;

		int max = (obj->type & obj->TYPE_OVERLAY) ? obj->GetFilterNum()-2 : obj->GetFilterNum()-1;

		for(int i = 1; i <= max; i++) {
			filter_status[i] &= ~obj->FILTER_STATUS_FOLD;
		}
		filter_status[0] |= obj->FILTER_STATUS_FOLD;
		SendMessage(hwnd, WM_COMMAND, OBJDLG_COMMAND::FILTER_FOLD, 0);
		return true;
	}
};

////////////////////////////////////////////////////////////////////////////////
// O[oϐ
////////////////////////////////////////////////////////////////////////////////

HWND g_aviutl_hwnd = NULL;
HWND g_exedit_hwnd = NULL;

CObjectDialog g_objdlg;


////////////////////////////////////////////////////////////////////////////////
// ⏕֐
////////////////////////////////////////////////////////////////////////////////

// ΏۃtB^ɑ΂鏈
void ExtraCommand(auls::CFilterWrapper fp, int cmd)
{
	switch(cmd) {
		case SMI_SET_TARGET_1:
		case SMI_SET_TARGET_2:
		case SMI_SET_TARGET_3:
		case SMI_SET_TARGET_4:
		case SMI_SET_TARGET_5:
		case SMI_SET_TARGET_6:
		case SMI_SET_TARGET_7:
		case SMI_SET_TARGET_8:
		case SMI_SET_TARGET_9:
		case SMI_SET_TARGET_10:
		case SMI_SET_TARGET_11:
		case SMI_SET_TARGET_12:
			fp->SetTrackValue(0, cmd - SMI_SET_TARGET_1 + 1, true);
			break;
		case SMI_TARGET_MOVEUP:
			if(g_objdlg.FilterMoveUp(fp->track[0]-1)) {
				fp->AddTrackValue(0, -1, true);
			}
			break;
		case SMI_TARGET_MOVEDOWN:
			if(g_objdlg.FilterMoveDown(fp->track[0]-1)) {
				fp->AddTrackValue(0, 1, true);
			}
			break;
		case SMI_TARGET_DELETE:
			g_objdlg.FilterDelete(fp->track[0]-1);
			break;
		case SMI_TARGET_INIT:
			g_objdlg.FilterInit(fp->track[0]-1);
			break;
		case SMI_TARGET_VALIDATE:
			g_objdlg.FilterValidate(fp->track[0]-1);
			break;
		case SMI_TARGET_FOLD:
			g_objdlg.FilterFold(fp->track[0]-1);
			break;
		case SMI_FILTER_TARGET_MAKE_ALIAS:
			g_objdlg.FilterMakeAlias(fp->track[0]-1);
			break;
		case SMI_FILTER_VALIDATE_ALL:
			g_objdlg.FilterValidateAll();
			break;
		case SMI_FILTER_INVALIDATE_EXCEPT_TOP_AND_TARGET:
			g_objdlg.FilterInvalidateExceptTopAndTarget(fp->track[0]-1);
			break;
		case SMI_FILTER_FOLD_EXCEPT_TARGET:
			g_objdlg.FilterFoldExceptTarget(fp->track[0]-1);
			break;
		case SMI_FILTER_UNFOLD_ALL:
			g_objdlg.FilterUnfoldAll();
			break;
		case SMI_OBJDLG_RESET_POS:
			g_objdlg.ResetWindowPos();
			break;
		case SMI_CHANGE_MEDIA_DEST:
		case SMI_CHANGE_EFFECT_DEST:
		case SMI_CHANGE_FILTER_DEST:
			fp->ReverseCheckValue(cmd - SMI_CHANGE_MEDIA_DEST, true);
			break;
		case SMI_SELECT_SCENE:
			SendMessage(g_exedit_hwnd, WM_LBUTTONDOWN, 0, 0);
			break;
	}
}

void AddFilter(FILTER *fp, int id)
{
	switch(FILTER_CATEGORY[id-auls::EXEDIT_FILTER_ID_BEGIN]) {
		case 1:
			SendMessage((*g_objdlg.obj_index == -1 || fp->check[0]) ? g_exedit_hwnd : g_objdlg.hwnd, WM_COMMAND, id, 0);
			break;
		case 2:
			SendMessage(g_objdlg.hwnd, WM_COMMAND, id, 0);
			break;
		case 3:
			SendMessage(g_exedit_hwnd, WM_COMMAND, id, 0);
			break;
		case 4:
			SendMessage((*g_objdlg.obj_index == -1 || fp->check[1]) ? g_exedit_hwnd : g_objdlg.hwnd, WM_COMMAND, id, 0);
			break;
		case 5:
			SendMessage((*g_objdlg.obj_index == -1 || fp->check[2]) ? g_exedit_hwnd : g_objdlg.hwnd, WM_COMMAND, id, 0);
			break;
	}
}

////////////////////////////////////////////////////////////////////////////////
// tB^֐
////////////////////////////////////////////////////////////////////////////////




// tB^
BOOL func_init(FILTER *fp)
{
	g_aviutl_hwnd = GetWindow(fp->hwnd, GW_OWNER);

	FILTER* exedit = auls::Exedit_GetFilter(fp);
	if(!exedit) return FALSE;
	g_exedit_hwnd = exedit->hwnd;

	// QƂ̏
	auls::CMemref memref;
	if(!memref.Init(fp)) goto memref_failure;
	EXEDIT_FILTER** filter_table = memref.Exedit_StaticFilterTable();

	if(!filter_table || !g_objdlg.SetMemory(&memref)) goto memref_failure;

	// QƂ̎s
	if(0) {
		memref_failure:
		MessageBox(g_aviutl_hwnd, memref.GetErrorString(), FILTER_INFORMATION, MB_OK | MB_ICONINFORMATION);
		return FALSE;
	}

	int (*add_menu_item)(void*, LPSTR, HWND, int, int, int) = fp->exfunc->add_menu_item;

	// eݒV[gJbgǉ
	fp->name = "ǉV[gJbg(eݒ)";
	for(int i = 0; i < sizeof(EXEDIT_MENU) / sizeof(*EXEDIT_MENU); i++) {
		add_menu_item(fp, EXEDIT_MENU[i].name, g_exedit_hwnd, EXEDIT_MENU[i].id, 0, 0);
	}
	for(int i = 0; i < sizeof(SHORTCUT_MENU) / sizeof(*SHORTCUT_MENU); i++) {
		add_menu_item(fp, SHORTCUT_MENU[i].name, fp->hwnd, SHORTCUT_MENU[i].id, 0, 0);
	}


	// fBAIuWFNgzuV[gJbgǉ
	fp->name = "ǉV[gJbg(fBAIuWFNg)";
	for(DWORD i = 0; filter_table[i]; i++) {
		if(FILTER_CATEGORY[i] >= 1 && FILTER_CATEGORY[i] <= 3) {
			add_menu_item(fp, (LPSTR)filter_table[i]->name, fp->hwnd, auls::EXEDIT_FILTER_ID_BEGIN + i, 0, 0);
		}
	}

	// tB^ʔzuV[gJbgǉ
	fp->name = "ǉV[gJbg(tB^)";
	for(DWORD i = 0; filter_table[i]; i++) {
		if(FILTER_CATEGORY[i] == 4) {
			add_menu_item(fp, (LPSTR)filter_table[i]->name, fp->hwnd, auls::EXEDIT_FILTER_ID_BEGIN + i, 0, 0);
		}
	}

	// tB^IuWFNgzuV[gJbgǉ
	fp->name = "ǉV[gJbg(tB^IuWFNg)";
	for(DWORD i = 0; filter_table[i]; i++) {
		if(FILTER_CATEGORY[i] == 5) {
			add_menu_item(fp, (LPSTR)filter_table[i]->name, fp->hwnd, auls::EXEDIT_FILTER_ID_BEGIN + i, 0, 0);
		}
	}

	fp->name = (LPSTR)FILTER_NAME;
	return TRUE;
}

// EBhEbZ[W̏
BOOL func_WndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp, void *editp, FILTER *fp)
{
	switch(msg) {
		case WM_FILTER_CHANGE_WINDOW:
			if(!g_objdlg.hwnd) {
				// WM_FILTER_INIŤAŏɌĂяo郁bZ[W
				// ̃^C~OłȂƁAtB^̃[hɂĂ̓IuWFNgݒ_CAO쐬ĂȂ
				g_objdlg.hwnd = auls::ObjDlg_GetWindow(g_exedit_hwnd);
			}
			break;

		case WM_FILTER_COMMAND:
			{
				int cmdid = LOWORD(wp);
				if(cmdid >= SHORTCUT_ID_BEGIN) {
					ExtraCommand(fp, LOWORD(wp));
				} else if(cmdid >= auls::EXEDIT_FILTER_ID_BEGIN && cmdid < auls::EXEDIT_ALIAS_ID_BEGIN) {
					AddFilter(fp, cmdid);
				} else {
					SendMessage(g_exedit_hwnd, WM_COMMAND, wp, lp);
				}
			}
			break;
	}
	
	return FALSE;
}

////////////////////////////////////////////////////////////////////////////////
// tB^o^
////////////////////////////////////////////////////////////////////////////////

LPSTR track_name[] = { "Ώ" };
int   track_def[]  = { 1 };
int   track_min[]  = { 1 };
int   track_max[]  = { 12 };

LPSTR check_name[] = { "fBAIuWFNgTLɔzu", "tB^ʂTLɔzu", "tB^IuWFNgTLɔzu" };
int   check_def[]  = { 1, 0, 0, 1 };

FILTER_DLL filter = {
	FILTER_FLAG_ALWAYS_ACTIVE | FILTER_FLAG_EX_INFORMATION,
	0, 0,
	FILTER_NAME,
	1, track_name, track_def, track_min, track_max,
	3, check_name, check_def,
	NULL,
	func_init,
	NULL,
	NULL,
	func_WndProc,
	NULL,
	NULL,
	NULL,
	NULL,
	FILTER_INFORMATION,
};

extern "C" __declspec(dllexport) FILTER_DLL *GetFilterTable(void)
{
	return &filter;
}
